<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function factory() {
        return new self();
    }

    public function getFaculties() {
        $sql = "CALL `GetFaculties`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getJobPositions() {
        $sql = "CALL `GetJobPositions`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getTeachersForDiscipline($disciplineID) {
        $sql = "CALL `GetTeachersForDiscipline`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getTeachersByFaculty($facultyID) {
        $sql = "CALL `GetTeachersByFaculty`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function byFaculty($facultyID) {
        if ($facultyID != 0) {
            $teachers = $this->getTeachersByFaculty($facultyID);
            $i = 0;
            foreach ($teachers as $row) {
                $i++;
                $teachersHandled[$i]['ID'] = $row['ID'];
                $teachersHandled[$i]['AccountID'] = $row['AccountID'];
                $teachersHandled[$i]['FirstName'] = $row['FirstName'];
                $teachersHandled[$i]['SecondName'] = $row['SecondName'];
                $teachersHandled[$i]['LastName'] = $row['LastName'];
                $teachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
                $teachersHandled[$i]['DepartmentID'] = $row['DepID'];
                $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
            }
        }
        return new DataArray_Result($teachersHandled);
    }

    public function byDepartment($departmentID) {
        $teachers = $this->getTeachersByDepartment($departmentID);
        $i = 0;
        foreach ($teachers as $row) {
            $i++;
            $teachersHandled[$i]['ID'] = $row['ID'];
            $teachersHandled[$i]['AccountID'] = $row['AccountID'];
            $teachersHandled[$i]['FirstName'] = $row['FirstName'];
            $teachersHandled[$i]['SecondName'] = $row['SecondName'];
            $teachersHandled[$i]['LastName'] = $row['LastName'];
            $teachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
            $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
        }
        return new DataArray_Result($teachersHandled);
    }

    public function forDiscipline($disciplineID, $asConcat = false, $asInitials = false) {
        $teachers = $this->getTeachersForDiscipline($disciplineID);
        $teachersHandled = array();
        $i = 0;
        foreach ($teachers as $teacher) {
            $i++;
            $tchr = array();
            $tchr['IsAuthor'] = $teacher['IsAuthor'];
            $tchr['ID'] = $teacher['ID'];
            $tchr['LastName'] = $teacher['LastName'];
            $tchr['FirstName'] = $asInitials ? UTF8::substr($teacher['FirstName'], 0, 1) . '. ' : $teacher['FirstName'];
            if (!empty($teacher['SecondName'])) $tchr['SecondName'] = $asInitials ? UTF8::substr($teacher['SecondName'], 0, 1) . '. ' : $teacher['SecondName'];
            if ($asConcat) $teachersHandled[$i] = $tchr['LastName'] . $tchr['FirstName'] . $tchr['SecondName']; else
                $teachersHandled[$i] = $tchr;
        }
        return new DataArray_Result($teachersHandled);
    }

    public function getTeachersByDepartment($departmentID) {
        $sql = "CALL `GetTeachersByDepartment`('$departmentID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getDepartmentsByFaculty($facultyID) {
        $sql = "CALL `GetDepartments`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function searchTeachers($FacultyID, $DepartmentID, $Last, $First, $Second) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', $Last, $First, $Second); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function searchTeacherNew($FacultyID, $DepartmentID, $Last, $First, $Second, $DisciplineID) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeacherNew`('$FacultyID', '$DepartmentID', $Last, $First, $Second, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
}